"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImportMetaReplacer = void 0;
const tslib_1 = require("tslib");
const typescript_transformer_common_1 = require("@build-script/typescript-transformer-common");
const typescript_1 = tslib_1.__importDefault(require("typescript"));
class ImportMetaReplacer extends typescript_transformer_common_1.NodeReplacer {
    replacer;
    kinds = [typescript_1.default.SyntaxKind.PropertyAccessExpression];
    constructor(replacer) {
        super();
        this.replacer = replacer;
    }
    check(node) {
        return (typescript_1.default.isPropertyAccessExpression(node) &&
            typescript_1.default.isMetaProperty(node.expression) &&
            typescript_1.default.idText(node.expression.name) === 'meta');
    }
    _replace(node, context) {
        return this.replacer(typescript_1.default.idText(node.name), node, context, this.logger);
    }
    static UrlToFilename(key, _, { factory }) {
        if (key !== 'url') {
            return;
        }
        return factory.createParenthesizedExpression(factory.createBinaryExpression(factory.createStringLiteral('file://'), typescript_1.default.SyntaxKind.PlusToken, factory.createIdentifier('__filename')));
    }
}
exports.ImportMetaReplacer = ImportMetaReplacer;
//# sourceMappingURL=importMetaReplacer.cjs.map
